variables:
#  DOCKER_HOST: tcp://localhost:2375
  DOCKER_DRIVER: overlay2
  SCRAPING_TAG: $CI_REGISTRY_IMAGE:scraping-$CI_COMMIT_SHORT_SHA
  SCRAPING_TAG_LATEST: $CI_REGISTRY_IMAGE:scraping-latest
  DEMOSITE_TAG: $CI_REGISTRY_IMAGE:demosite-$CI_COMMIT_SHORT_SHA
  DEMOSITE_TAG_LATEST: $CI_REGISTRY_IMAGE:demosite-latest

stages:
  - build
  - deploy

build:scraping:
  stage: build
  image: docker:stable
  allow_failure: true
  services:
  - docker:dind
  before_script:
  - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" "$CI_REGISTRY" --password-stdin
  script:
  - docker pull $SCRAPING_TAG_LATEST || true
  - docker build --cache-from $SCRAPING_TAG_LATEST --tag $SCRAPING_TAG --tag $SCRAPING_TAG_LATEST .
  - docker push $SCRAPING_TAG
  - docker push $SCRAPING_TAG_LATEST

build:site:
  stage: build
  image: docker:stable
  services:
  - docker:dind
  before_script:
  - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" "$CI_REGISTRY" --password-stdin
  script:
  - docker pull $DEMOSITE_TAG_LATEST || true
  - docker build --cache-from $DEMOSITE_TAG_LATEST --tag $DEMOSITE_TAG --tag $DEMOSITE_TAG_LATEST -f ./demo/Dockerfile ./demo
  - docker push $DEMOSITE_TAG
  - docker push $DEMOSITE_TAG_LATEST

deploy:site:
  stage: deploy
  image: registry.gitlab.com/gitlab-examples/kubernetes-deploy
  environment: production
  script:
  - sed "s@<IMAGE>@${DEMOSITE_TAG}@g" orch/demo-site.yaml | kubectl apply -f -
